unit BUtil_Shared;

interface

uses
  Windows;

function CmdLineExecAsync(const CmdLine: string): THandle;
procedure CmdLineExecSync(const CmdLine: string);

implementation

uses
  sysutils;

// Asinhrono izvrsava (kreira proces i ne ceka na zavrsetak njegovog
// izvrsavanja) komandnu liniju 'CmdLine' i vraca handle na kreirani proces.
// Ako ne uspe, baca izuzetak.
function CmdLineExecAsync(const CmdLine: string): THandle;
var
  SInfo: TStartupInfo;
  PRocInfo: TProcessInformation;
begin

  FillChar(SInfo,SizeOf(SInfo),0);
  SInfo.cb := SizeOf(SInfo);

  if CreateProcess(
    nil,
    PChar(CmdLine),
    nil,
    nil,
    BOOL(true),
    0,
    nil,
    nil,
    SInfo,
    ProcInfo
  ) <> BOOL(0)
  then
  begin
    CloseHandle(ProcInfo.hThread);
    result := ProcInfo.hProcess
  end
  else
    raise Exception.Create('CmdLineExecAsync() Error creating proccess for command line: ' + CmdLine)

end;

// Sinhrono izvrsava komandnu liniju zadatu u 'CmdLine' - ceka
// da krairani proces zavrsi izvrsavanja.
// Baca izuzetak ako nesto podje naopako.
procedure CmdLineExecSync(const CmdLine: string);
var
  PH: THandle;
begin

  // Kreiramo proces.
  PH := CmdLineExecAsync(CmdLine);

  // Pa cekamo da se zavrsi.
  if WaitForSingleObject(PH,INFINITE) = WAIT_FAILED then
    raise Exception.Create('CmdLineExecSync() Error waiting process to terminate.');
  CloseHandle(PH);
end;


end.
 