unit HyperlinkLabel_Design;

interface

procedure Register;

implementation

uses
  Classes, DsgnIntf, dialogs, forms, HyperlinkLabel;

type

  THyperlinkPrefixProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  TTargetURLProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(string),THyperlinkLabel,'HyperlinkPrefix',THyperlinkPrefixProperty);
  RegisterPropertyEditor(TypeInfo(string),THyperlinkLabel,'TargetURL',TTargetURLProperty);
end;



{ THyperlinkPrefixProperty }

function THyperlinkPrefixProperty.GetAttributes: TPropertyAttributes;
begin
  result := [paMultiSelect, paValueList, paSortList, paRevertable];
end;

procedure THyperlinkPrefixProperty.GetValues(Proc: TGetStrProc);
begin
  Proc('http://');
  Proc('https://');
  Proc('ftp://');
  Proc('mailto:');
  Proc('file://');
  Proc('gopher://')
end;



{ TTargetURLProperty }

function TTargetURLProperty.GetAttributes: TPropertyAttributes;
begin
  result := [paMultiSelect, paDialog, paRevertable];
end;

procedure TTargetURLProperty.Edit;
var
  //Dir: string;
  //i: integer;
  Dialog: TOpenDialog;
begin

  Dialog := TOpenDialog.Create(Application);
  try
    Dialog.Filter := 'All files (*.*)|*.*|HTML Files (*.htm;*.html)|*.htm;*.html|Text Files (*.txt;*.rtf;*.doc)|*.txt;*.rtf;*.doc|Archives (zip;arj;rar;cab;ace;tar;gz;lha;arc)|*.zip;*.arj;*.rar;*.cab;*.ace;*.tar;*.gz;*.lha;*.arc|Executable Files (*.exe)|*.exe';
    Dialog.FileName := Value;
    if Dialog.Execute then
      Value := Dialog.FileName;
  finally
    Dialog.Free;
  end;

  (*
  if SelectDirectory('Select local URL. Non-local URLs must be entered manually.','',Dir) then
  begin
    for i := 0 to PropCount-1 do
      (GetComponent(i) as THyperlinkLabel).HyperlinkPrefix := 'file://';
    Value := Dir;
    Modified := true
  end
  *)
end;



end.
